#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <unordered_map>
using namespace std;

// +oo
#define INFTY 99999999

// Bunch of macros to save some writing.
#define ii   pair<int, int>
#define vi   vector<int>
#define vd   vector<double>
#define vii  vector<ii>
#define vvi  vector<vi>
#define vvd  vector<vd>
#define vvii vector<vii>


bool floyd_warshall(vvd &distances)
{
	for (int k = 0; k < distances.size(); ++k)
		for (int u = 0; u < distances.size(); ++u)
			for (int v = 0; v < distances.size(); ++v)
				if (distances[u][v] > distances[u][k] + distances[k][v])
					distances[u][v] = distances[u][k] + distances[k][v];

	for (int k = 0; k < distances.size(); ++k)
		if (distances[k][k] < 0.0)
			return true;

	return false;
}


int main(void)
{
	int n, m;
	float r;
	string s, d;
	unordered_map<string, int> c2i;

	for (int i = 1; cin >> n && n; ++i)
	{
		vvd distances(n, vd(n, INFTY));

		for (int u = 0; u < distances.size(); ++u)
			distances[u][u] = 0;

		c2i.clear();

		for (int i = 0; i < n; ++i)
		{
			cin >> s;
			c2i[s] = i;
		}

		cin >> m;

		for (int i = 0; i < m; ++i)
		{
			cin >> s >> r >> d;
			distances[c2i[s]][c2i[d]] = -log(r);
		}

		cout << "Case " << i << ": " << (floyd_warshall(distances) ? "Yes" : "No") << endl;
	}

	return 0;
}